CEL: Crystal Entity Layer: iPcNavGraphRules Struct Reference (CEL: Crystal Entity Layer Public API Reference)

| ## Public API Reference

- Main Page
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# iPcNavGraphRules Struct Reference

Interfaces for the navigation classes. More...

`#include <propclass/navgraph.h>`

List of all members.

## Public Member Functions
virtual size_t | FindNearestNode (iPcNavGraph *graph, csVector3 *point, iSector *sector, iCelEntity *ent)=0
| Various virtual methods that can be used to change the graph behaviour.
virtual size_t | FindShortestPath (iPcNavGraph *graph, size_t iNodeStart, size_t iNodeEnd, size_t *&ipath)=0
| Various virtual methods that can be used to change the graph behaviour.
virtual void | OptimiseGraph (iPcNavGraph *graph)=0
| Various virtual methods that can be used to change the graph behaviour.
virtual int | TraverseLink (iPcNavGraph *graph, iSector *sector, iPcNavLink *plink, iCelEntity *ent)=0
| Various virtual methods that can be used to change the graph behaviour.

## Detailed Description

Interfaces for the navigation classes.

Definition at line 38 of file navgraph.h.

## Member Function Documentation

virtual size_t iPcNavGraphRules::FindNearestNode | ( | iPcNavGraph * | graph,
|  | csVector3 * | point,
|  | iSector * | sector,
|  | iCelEntity * | ent |
| ) |  |  | `[pure virtual]`

Various virtual methods that can be used to change the graph behaviour.

Find the nearest node to this point.

virtual size_t iPcNavGraphRules::FindShortestPath | ( | iPcNavGraph * | graph,
|  | size_t | iNodeStart,
|  | size_t | iNodeEnd,
|  | size_t *& | ipath |
| ) |  |  | `[pure virtual]`

Various virtual methods that can be used to change the graph behaviour.

Calculate the shortest path between two nodes

virtual void iPcNavGraphRules::OptimiseGraph | ( | iPcNavGraph * | graph | ) | `[pure virtual]`

Various virtual methods that can be used to change the graph behaviour.

Sorts the final graph.

virtual int iPcNavGraphRules::TraverseLink | ( | iPcNavGraph * | graph,
|  | iSector * | sector,
|  | iPcNavLink * | plink,
|  | iCelEntity * | ent |
| ) |  |  | `[pure virtual]`

Various virtual methods that can be used to change the graph behaviour.

Checks visibility and assigns navigation flags.

The documentation for this struct was generated from the following file:

- propclass/navgraph.h